## passwordsafe-1.20.0.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.13...3.25) # 3.13 is used by Debian 10

project (passwordsafe CXX C)

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
# wxWidgets 3.2.1 doesn't compile under C++17 on some distros.
# 3.0.5 is fine, though...
# Need to revisit this and remove when no longer an issue
if (NOT WIN32 OR WX_WINDOWS)
    set(CMAKE_CXX_STANDARD 14)
else (NOT WIN32 OR WX_WINDOWS)
    set(CMAKE_CXX_STANDARD 17)
endif (NOT WIN32 OR WX_WINDOWS)

# prerequisites
include(CheckLibraryExists)
include(CheckIncludeFile)

# IPO = interprocedural optimisation, not initial public offering (unfortunately)
include(CheckIPOSupported OPTIONAL RESULT_VARIABLE CHECK_IPO_FOUND)
if (${CHECK_IPO_FOUND} STREQUAL "NOTFOUND")
else (${CHECK_IPO_FOUND} STREQUAL "NOTFOUND")
  check_ipo_supported(RESULT IPO_SUPPORTED)
endif (${CHECK_IPO_FOUND} STREQUAL "NOTFOUND")

if (IPO_SUPPORTED)
  option(USE_INTERPROCEDURAL_OPTIMIZATION "Enable interprocedural optimization (LTO/LTCG)" ON)

  if (USE_INTERPROCEDURAL_OPTIMIZATION)
    message(STATUS "Interprocedural optimization (LTO/LTCG) is enabled.")
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION ON)
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_DEBUG OFF)

    # Propagate IPO settings to subdirectories
    set(CMAKE_POLICY_DEFAULT_CMP0069 NEW)
  endif ()
endif (IPO_SUPPORTED)

if (UNIX)
  set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
endif ()

if (NOT WIN32)
include(FindUnixCommands)
endif (NOT WIN32)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules")

include(create-harden-interface)


# Configurable options:
option (NO_YUBI "Set ON to disable YubiKey support" OFF)
option (NO_GTEST "Set ON to disable gtest unit testing" OFF)
option (GTEST_BUILD "Set OFF to disable gtest download and build on-fly" ON)

if (WIN32)
  option (WX_WINDOWS "Build wxWidget under Windows" OFF)
  if (WX_WINDOWS)
    option (XML_XERCESC "Set ON for XML import support with XercesC" ON)
  else (WX_WINDOWS)
    option (XML_MSXML "Set ON for XML import support with MSXML" ON)
    option (XML_XERCESC "Set ON for XML import support with XercesC" OFF)    
  endif (WX_WINDOWS)
  if (XML_MSXML AND XML_XERCESC)
    message (FATAL_ERROR "MSXML and XERCESC are mutually exclusive")
  endif (XML_MSXML AND XML_XERCESC)
  if (XML_MSXML AND WX_WINDOWS)
    message (FATAL_ERROR "MSXML is not supported for wxWidget under Windows")
  endif (XML_MSXML AND WX_WINDOWS)
else (WIN32)
  option (XML_XERCESC "Set OFF to disable XML import support" ON)
endif (WIN32)
if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  option (USE_ASAN "Set ON to add -fsanitize=address to Debug builds" OFF)
endif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  option (NO_QR "Set ON to disable QR support" OFF)
  if (NOT NO_QR)
    CHECK_INCLUDE_FILE("qrencode.h" HAVE_LIBQRENCODE_DEV)
    if(NOT HAVE_LIBQRENCODE_DEV)
      unset(HAVE_LIBQRENCODE_DEV CACHE)
      message( FATAL_ERROR "libqrencode-dev(el) not installed: install or select NO_QR")
    endif(NOT HAVE_LIBQRENCODE_DEV)
  else (NOT NO_QR)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNO_QR")
  endif (NOT NO_QR)
else(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

if (NOT WIN32 OR WX_WINDOWS)
  if (NOT WIN32)
     # help people with wxWidgets on non-standard installation
     # quick-and-dirty since wxWdigets cmake's support is not yet loaded.
     find_program(PWSHINT_wxconfig wx-config)
     if (NOT PWSHINT_wxconfig)
       message(STATUS
               "Failed to find 'wx-config' executable:\n"
               "   Tip: can be pointed from command-line this way:\n"
               "        $ cmake -D wxWidgets_CONFIG_EXECUTABLE=/path/to/wx-config ."
               )
     endif (NOT PWSHINT_wxconfig)
  endif (NOT WIN32)
  find_package(wxWidgets COMPONENTS adv aui base core html net REQUIRED)
  include(${wxWidgets_USE_FILE})

  find_package(OpenSSL REQUIRED)
  include_directories(${OPENSSL_INCLUDE_DIR})

  find_package(Magic REQUIRED)
  include_directories(${MAGIC_INCLUDE_DIRS})
endif (NOT WIN32 OR WX_WINDOWS)

if (NOT WIN32)
    if (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
      set( CMAKE_REQUIRED_INCLUDES "/usr/local/include" )
    endif (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    if (${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")
	  CHECK_INCLUDE_FILE("uuid.h" UUID_H)
    else ()
	  CHECK_INCLUDE_FILE("uuid/uuid.h" UUID_H)
    endif (${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")
  if (NOT UUID_H)
    message(FATAL_ERROR
      "uuid.h not found - uuid-dev / libuuid-devel not installed?")
  endif(NOT UUID_H)
  if(NOT NO_YUBI)
    CHECK_LIBRARY_EXISTS(ykpers-1 yk_init "ykpers-1/ykpers.h" HAVE_YKPERS_H)
  endif(NOT NO_YUBI)

  if(NOT HAVE_YKPERS_H)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNO_YUBI")
    message(STATUS "Yubikey support disabled")
  endif(NOT HAVE_YKPERS_H)
endif (NOT WIN32)

if (XML_XERCESC)
  find_package (XercesC QUIET MODULE)
  if (NOT XercesC_FOUND)
    # FindXercesC module was added to cmake in 3.1. Debian 8 uses 3.0.2
    # If the module wasn't found yet XML is enabled, we set the default
    # values. If this isn't what you want, either configure NO_XML
    # or edit the following values manually.
    if (NOT XercesC_INCLUDE_DIR)
      message (WARNING "XML enabled but XercesC_INCLUDE_DIR unset - using default")
      set (XercesC_INCLUDE_DIR "/usr/include")
    endif ()
    if (NOT XercesC_LIBRARY)
      message (WARNING "XML enabled but XercesC_LIBRARY unset - using default")
      set (XercesC_LIBRARY "xerces-c")
    endif ()
  endif(NOT XercesC_FOUND)
  include_directories( ${XercesC_INCLUDE_DIR} )
  add_definitions ("-DUSE_XML_LIBRARY=XERCES")
endif (XML_XERCESC)

if (XML_MSXML)
  add_definitions ("-DUSE_XML_LIBRARY=MSXML")
  set (MSXML_LIB "msxml6")
endif (XML_MSXML)

if (USE_ASAN)
  # Requires libasan, which I can't get CHECK_LIBRARY_EXISTS to find under Debian
  CHECK_LIBRARY_EXISTS("asan" "" "" HAS_ASAN)
  CHECK_LIBRARY_EXISTS("asan" "" "/usr/lib/x86_64-linux-gnu/" HAS_ASAN1)
  if (NOT HAS_ASAN AND NOT HAS_ASAN1)
    message (WARNING
      "-fsanitize=address requested but libasan not found.")
  endif (NOT HAS_ASAN AND NOT HAS_ASAN1)
endif (USE_ASAN)

enable_testing()

# Common configurations

include_directories (${PROJECT_SOURCE_DIR}/src/os)
include_directories (${PROJECT_SOURCE_DIR}/src/core)
include_directories (${PROJECT_BINARY_DIR})
include_directories ("${PROJECT_SOURCE_DIR}/src"
  "${PROJECT_SOURCE_DIR}/src/core"
  "${PROJECT_SOURCE_DIR}/src/ui/wxWidgets")

add_compile_definitions(
  __STDC_WANT_LIB_EXT1__=1
  UNICODE
  $<$<CONFIG:DEBUG>:_DEBUG>
  $<$<NOT:$<CONFIG:DEBUG>>:NDEBUG>
)

# Assume that we're either MSVC or a Unix-like
if (MSVC)
# Debug build looks for dlls with _D postfix, this provides it:
set (CMAKE_DEBUG_POSTFIX "_D")
# This copies dlls to same directory as exec upon 'install' build
set (CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR})

set_property (GLOBAL PROPERTY USE_FOLDERS ON)

if (NO_YUBI)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNO_YUBI")
endif (NO_YUBI)

if (WX_WINDOWS)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D __WX__")
endif (WX_WINDOWS)

include(set-options-msvc)
else ()
set(CMAKE_CXX_FLAGS
  "${CMAKE_CXX_FLAGS} -Wall -DUNICODE -DWCHAR_INCOMPATIBLE_XMLCH ${CMAKE_WXWINDOWS_CXX_FLAGS}")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -D_DEBUG -DDEBUG")
if (USE_ASAN)
  set(CMAKE_CXX_FLAGS_DEBUG
    "${CMAKE_CXX_FLAGS_DEBUG} -gdwarf-4 -O0 -fno-omit-frame-pointer -fno-optimize-sibling-calls -fsanitize=address")
endif (USE_ASAN)
endif (MSVC)

if (NOT NO_GTEST AND GTEST_BUILD)
   # Download and unpack googletest at configure time
   # See https://crascit.com/2015/07/25/cmake-gtest/
   configure_file(Misc/CMakeLists.gtest.txt.in googletest-download/CMakeLists.txt)
   execute_process(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
       WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googletest-download" )
   execute_process(COMMAND "${CMAKE_COMMAND}" --build .
       WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googletest-download" )

   # Prevent GoogleTest from overriding our compiler/linker options
   # when building with Visual Studio
   set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
   # Set some other gtest configurations:
   set(BUILD_GMOCK OFF CACHE BOOL "" FORCE)
   set(BUILD_GTEST ON CACHE BOOL "" FORCE)
   set(INSTALL_GTEST OFF CACHE BOOL "" FORCE)

   # Add googletest directly to our build. This adds
   # the following targets: gtest, gtest_main, gmock
   # and gmock_main
   add_subdirectory("${CMAKE_BINARY_DIR}/googletest-src"
                    "${CMAKE_BINARY_DIR}/googletest-build")

   include_directories("${gtest_SOURCE_DIR}/include"
#                       "${gmock_SOURCE_DIR}/include"
                       )
endif(NOT NO_GTEST AND GTEST_BUILD)

if( NOT CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release )
endif( NOT CMAKE_BUILD_TYPE )

if(HAVE_YKPERS_H)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -I/usr/include/ykpers-1")
  list(APPEND CMAKE_REQUIRED_LIBRARIES ykpers-1)
endif(HAVE_YKPERS_H)

if (NOT MSVC)
   # Following is because (a) -O3 breaks the test and application, and
   # (b) -O3 is the default for cmake
   set (CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG")
endif (NOT MSVC)

include(pws-version)

if (WIN32)
   set (CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
endif (WIN32)

# Subdirectories

add_subdirectory (src/os) # os-specific library
add_subdirectory (src/core) # core library
add_subdirectory(src/ui/cli "./cli")
if (NOT NO_GTEST)
   add_subdirectory (src/test) # tests (gtest framework)
endif(NOT NO_GTEST)
add_subdirectory (help) # online help
if (WIN32 AND NOT WX_WINDOWS)
  add_subdirectory (src/Tools/Windows/I18N/ResText)
  add_subdirectory (src/Tools/Windows/I18N/ResPWSL)
  add_subdirectory (src/ui/Windows)
  add_subdirectory (src/ui/Windows/I18N)
else()
  add_subdirectory (src/ui/wxWidgets)
  if (NOT WIN32)
    # TBD - handle I18N under WX_WINDOWS.
    find_package(Gettext QUIET)
    if (GETTEXT_FOUND)
      add_subdirectory (src/ui/wxWidgets/I18N)
    else (GETTEXT_FOUND)
      message("Gettext support not found, skipping I18N build")
    endif(GETTEXT_FOUND)
  endif (NOT WIN32)
endif()

if (NOT WIN32)
  add_executable(pwsafe ${PWSAFE_SRCS})
else (NOT WIN32)
   add_executable(pwsafe WIN32 ${PWSAFE_SRCS})
   add_dependencies( pwsafe language-dlls) # i18n dlls
   if (NOT WX_WINDOWS)
      set (PWS_DLL_LIBS "pws_at" "pws_osk")
      set_target_properties(pwsafe PROPERTIES COMPILE_DEFINITIONS
                            "_BIND_TO_CURRENT_CRT_VERSION;_BIND_TO_CURRENT_MFC_VERSION"
                            LINK_FLAGS "/ENTRY:\"wWinMainCRTStartup\" /MAP /DEBUG")
   else (NOT WX_WINDOWS)
#      set_target_properties(pwsafe PROPERTIES COMPILE_DEFINITIONS
#                            _BIND_TO_CURRENT_CRT_VERSION
#                            LINK_FLAGS "/ENTRY:\"wWinMainCRTStartup\"")
   endif (NOT WX_WINDOWS)
endif (NOT WIN32)
target_link_libraries(pwsafe core os)
if (XML_XERCESC)
  target_link_libraries(pwsafe ${XercesC_LIBRARY})
endif (XML_XERCESC)

target_link_libraries(pwsafe pws_version)

if (APPLE)
  FIND_LIBRARY(QUARTZCORE_LIBS QuartzCore)
  target_link_libraries(pwsafe ${wxWidgets_LIBRARIES} ${CMAKE_REQUIRED_LIBRARIES} ${QUARTZCORE_LIBS} curl ${OPENSSL_SSL_LIBRARY})
elseif (WIN32)
  if (NOT NO_YUBI)
    set (YUBILIB "YkLib22")
  endif ()
  target_link_libraries(pwsafe ${wxWidgets_LIBRARIES} 
      ${YUBILIB} ${PWS_DLL_LIBS} version Rpcrt4 htmlhelp SetupAPI Hid usp10
      Dbghelp Urlmon gdiplus ${MSXML_LIB} ${CMAKE_REQUIRED_LIBRARIES})
else ()
  if (NOT NO_QR)
    target_link_libraries(pwsafe qrencode  ${CMAKE_REQUIRED_LIBRARIES})
  endif (NOT NO_QR)
  target_link_libraries(pwsafe ${wxWidgets_LIBRARIES} uuid Xtst X11 curl ${OPENSSL_SSL_LIBRARY} ${MAGIC_LIBRARIES}
  ${CMAKE_REQUIRED_LIBRARIES})
endif()

# Installation stuff (for 'make install', but mainly for 'make package')
install (TARGETS pwsafe RUNTIME DESTINATION "bin")

target_link_libraries(pwsafe harden_interface)

=== install/macosx/Makefile ===
# Makefile to build a Mac OS X distribution package (.dmg)
#
#
#
# Define the correct TARGET and RELDIR below:
TARGET=pwsafe
PACKAGE=PasswordSafe-macOS
MACHINEARCH=universal

# XCODE_CONFIG and WX_SRC_DIR are defined in the macos-latest.yaml Github build workflow
ifndef XCODE_CONFIG
XCODE_CONFIG=Release
endif
RELDIR := $(shell xcodebuild -project ../../Xcode/pwsafe-xcode6.xcodeproj -showBuildSettings -scheme pwsafe -configuration $(XCODE_CONFIG) | awk '/TARGET_BUILD_DIR =/{print $$3}')

ifdef WX_SRC_DIR
WXDIR := $(WX_SRC_DIR)/locale
else
WXDIR := $(shell grep OTHER_LDFLAGS ../../Xcode/pwsafe-release.xcconfig | awk 'BEGIN { RS = " " } /-L/{print $$1}' | sed s/-L// | sed s,/[^/]*/lib,/locale,)
endif

#TARGET=pwsafe
#TARGET=pwsafe-i386
###TARGET=pwsafe64
#TARGET=pwsafe-llvm
#RELDIR=../../Xcode/build/Release/
#RELDIR=../../Xcode/build-i386/Release/
###RELDIR=../../Xcode/build64/Release/
#RELDIR=../../Xcode/build-llvm/Release/
#RELDIR=$(HOME)/Library/Developer/Xcode/DerivedData/pwsafe-xcode6-*/Build/Products/Release/
# RELDIR=./../../Xcode/build/Products/Release/
#RELDIR=$(shell xcodebuild -project ../../Xcode/pwsafe-xcode6.xcodeproj -showBuildSettings | grep TARGET_BUILD_DIR | awk 'BEGIN { } /TARGET_BUILD_DIR =/{print $$3}' | sed "s/$$/\//")
# Path to wxWidgets library path has to be adapted for each environment
# WXDIR=../../../wxWidgets-3.1.5/locale
# Machine architecture - these days we are building Universal Binaries
#MACHINEARCH=$(shell uname -m)

CPBIN=/bin/cp
RMBIN=/bin/rm
MDBIN=/bin/mkdir -p

include ../../version.wx

ifndef VER_REV
VER_REV = 0
endif

ifdef VER_SPECIAL
RELEASENAME := $(VER_MAJOR).$(VER_MINOR).$(VER_REV).$(VER_SPECIAL)
else
RELEASENAME := $(VER_MAJOR).$(VER_MINOR).$(VER_REV)
endif

SRCDIR=./dmg
DMGNAME := "../../$(PACKAGE)-$(RELEASENAME)-$(MACHINEARCH).dmg"
PWSAFE-APP := $(TARGET).app
RESOURCES := $(RELDIR)/pwsafe.app/Contents/Resources
DOCS := ../../README.md ../../docs/LICENSE.rtf ../../docs/ReleaseNotesWX.md ../../docs/Yubico
HELP := ../../help/helpEN.zip ../../help/helpRU.zip ../../help/helpDE.zip ../../help/helpES.zip ../../help/helpFR.zip ../../help/helpZH.zip ../../help/helpPL.zip
I18N := ../../src/ui/wxWidgets/I18N
MOS := $(I18N)/mos

all: loc help lang dist
	@echo Version $(RELEASENAME) generated in $(DMGNAME)

loc:
	@echo "Build location: $(RELDIR)"
	@echo "WX location: $(WXDIR)"

help:
	cd ../../help; make
	$(CPBIN) $(HELP) $(RESOURCES)

pwsI18N:
	cd $(I18N); make mos

wxlocale:
	cd $(WXDIR); make allmo

lang: pwsI18N wxlocale
	$(MDBIN) $(RESOURCES)/da.lproj
	$(CPBIN) $(MOS)/da/LC_MESSAGES/pwsafe.mo $(RESOURCES)/da.lproj
	$(CPBIN) $(WXDIR)/da.mo $(RESOURCES)/da.lproj/wxstd.mo
	$(MDBIN) $(RESOURCES)/de.lproj
	$(CPBIN) $(MOS)/de/LC_MESSAGES/pwsafe.mo $(RESOURCES)/de.lproj
	$(CPBIN) $(WXDIR)/de.mo $(RESOURCES)/de.lproj/wxstd.mo
	$(MDBIN) $(RESOURCES)/es.lproj
	$(CPBIN) $(MOS)/es/LC_MESSAGES/pwsafe.mo $(RESOURCES)/es.lproj
	$(CPBIN) $(WXDIR)/es.mo $(RESOURCES)/es.lproj/wxstd.mo
	$(MDBIN) $(RESOURCES)/fr.lproj
	$(CPBIN) $(MOS)/fr/LC_MESSAGES/pwsafe.mo $(RESOURCES)/fr.lproj
	$(CPBIN) $(WXDIR)/fr.mo $(RESOURCES)/fr.lproj/wxstd.mo
	$(MDBIN) $(RESOURCES)/hu.lproj
	$(CPBIN) $(MOS)/hu/LC_MESSAGES/pwsafe.mo $(RESOURCES)/hu.lproj
	$(CPBIN) $(WXDIR)/hu.mo $(RESOURCES)/hu.lproj/wxstd.mo
	$(MDBIN) $(RESOURCES)/it.lproj
	$(CPBIN) $(MOS)/it/LC_MESSAGES/pwsafe.mo $(RESOURCES)/it.lproj
	$(CPBIN) $(WXDIR)/it.mo $(RESOURCES)/it.lproj/wxstd.mo
	$(MDBIN) $(RESOURCES)/ko.lproj
	$(CPBIN) $(MOS)/ko/LC_MESSAGES/pwsafe.mo $(RESOURCES)/ko.lproj
	$(CPBIN) $(WXDIR)/ko_KR.mo $(RESOURCES)/ko.lproj/wxstd.mo
	$(MDBIN) $(RESOURCES)/nl.lproj
	$(CPBIN) $(MOS)/nl/LC_MESSAGES/pwsafe.mo $(RESOURCES)/nl.lproj
	$(CPBIN) $(WXDIR)/nl.mo $(RESOURCES)/nl.lproj/wxstd.mo
	$(MDBIN) $(RESOURCES)/pl.lproj
	$(CPBIN) $(MOS)/pl/LC_MESSAGES/pwsafe.mo $(RESOURCES)/pl.lproj
	$(CPBIN) $(WXDIR)/pl.mo $(RESOURCES)/pl.lproj/wxstd.mo
	$(MDBIN) $(RESOURCES)/ru.lproj
	$(CPBIN) $(MOS)/ru/LC_MESSAGES/pwsafe.mo $(RESOURCES)/ru.lproj
	$(CPBIN) $(WXDIR)/ru.mo $(RESOURCES)/ru.lproj/wxstd.mo
	$(MDBIN) $(RESOURCES)/sl.lproj
	$(CPBIN) $(MOS)/sl/LC_MESSAGES/pwsafe.mo $(RESOURCES)/sl.lproj
	$(CPBIN) $(WXDIR)/sl.mo $(RESOURCES)/sl.lproj/wxstd.mo
	$(MDBIN) $(RESOURCES)/sv.lproj
	$(CPBIN) $(MOS)/sv/LC_MESSAGES/pwsafe.mo $(RESOURCES)/sv.lproj
	$(CPBIN) $(WXDIR)/sv.mo $(RESOURCES)/sv.lproj/wxstd.mo
	$(MDBIN) $(RESOURCES)/zh.lproj
	$(CPBIN) $(MOS)/zh/LC_MESSAGES/pwsafe.mo $(RESOURCES)/zh.lproj
	$(CPBIN) $(WXDIR)/zh_CN.mo $(RESOURCES)/zh.lproj/wxstd.mo
#	$(CPBIN) $(WXDIR)/zh_TW.mo $(RESOURCES)/zh.lproj/wxstd.mo

dist: clean
	$(MDBIN) $(SRCDIR)
	$(CPBIN) -R $(DOCS) $(SRCDIR)
	$(CPBIN) -R $(RELDIR)/$(PWSAFE-APP) $(SRCDIR)
	/usr/bin/codesign -v --force --sign - -o runtime --entitlements \
		$(RELDIR)/../../Intermediates.noindex/pwsafe-xcode6.build/Release/pwsafe.build/pwsafe.app.xcent \
		--timestamp=none --generate-entitlement-der $(SRCDIR)/pwsafe.app
	create-dmg \
			--window-size 420 560 \
			--background ./background_flat_icon.png \
			--icon-size 40 \
			--volname "Password Safe" \
			--volicon $(SRCDIR)/$(PWSAFE-APP)/Contents/Resources/AppIcon.icns \
			--eula ../../LICENSE \
			--icon "$(PWSAFE-APP)" 00 110 \
			--app-drop-link 180 110 \
			--icon "README.md" 00  300 \
			--icon "ReleaseNotesWX.md" 140 300 \
			--icon "LICENSE.rtf" 00 380 \
			--icon "Yubico" 140 380 \
		$(DMGNAME) \
		$(SRCDIR)

clean-dist:
	@$(RMBIN) -f $(DMGNAME)

clean: clean-dist
	@$(RMBIN) -rf $(SRCDIR)

=== src/core/CMakeLists.txt ===
include(CheckLibraryExists)

set (CORE_SRCS
 
  CheckVersion.cpp
  Command.cpp
  CoreImpExp.cpp
  CoreOtherDB.cpp
  ExpiredList.cpp
  ItemAtt.cpp
  Item.cpp
  ItemData.cpp
  ItemField.cpp
  Match.cpp
  PolicyManager.cpp
  PWCharPool.cpp
  PWHistory.cpp
  PWPolicy.cpp
  PWSAuxParse.cpp
  PWScore.cpp
  PWSdirs.cpp
  PWSfile.cpp
  PWSfileHeader.cpp
  PWSfileV1V2.cpp
  PWSfileV3.cpp
  PWSfileV4.cpp
  PWSFilters.cpp
  PWSLog.cpp
  PWSprefs.cpp
  PWSrand.cpp
  PWStime.cpp
  Report.cpp
  RUEList.cpp
  StringX.cpp
  SysInfo.cpp
  TotpCore.cpp
  UnknownField.cpp
  UTF8Conv.cpp
  Util.cpp
  VerifyFormat.cpp
  XMLprefs.cpp
  crypto/AES.cpp
  crypto/BlowFish.cpp
  crypto/KeyWrap.cpp
  crypto/pbkdf2.cpp
  crypto/sha1.cpp
  crypto/sha256.cpp
  crypto/TwoFish.cpp
  crypto/external/Chromium/base32.cpp
  XML/XMLFileHandlers.cpp
  XML/XMLFileValidation.cpp
  pugixml/pugixml.cpp
  )

if (XML_MSXML)
  list (APPEND CORE_SRCS
    XML/MSXML/MFileSAX2Handlers.cpp
    XML/MSXML/MFileValidator.cpp
    XML/MSXML/MFileXMLProcessor.cpp
    XML/MSXML/MFilterSAX2Handlers.cpp
    XML/MSXML/MFilterXMLProcessor.cpp
  )
endif (XML_MSXML)

if (XML_XERCESC)
  list (APPEND CORE_SRCS
    XML/Xerces/XFileSAX2Handlers.cpp
    XML/Xerces/XFileValidator.cpp
    XML/Xerces/XFileXMLProcessor.cpp
    XML/Xerces/XFilterSAX2Handlers.cpp
    XML/Xerces/XFilterXMLProcessor.cpp
    XML/Xerces/XSecMemMgr.cpp
   )
endif (XML_XERCESC)

if (NOT XML_MSXML AND NOT XML_XERCESC)
  list (APPEND CORE_SRCS
    XML/Pugi/PFileXMLProcessor.cpp
    XML/Pugi/PFilterXMLProcessor.cpp
  )
endif (NOT XML_MSXML AND NOT XML_XERCESC)

if (NOT WIN32 OR WX_WINDOWS)
  list (APPEND CORE_SRCS ${CMAKE_CURRENT_BINARY_DIR}/core_st.cpp)
  if (WIN32)
    set (PERL_EXECUTABLE "Perl_executable_undefined" CACHE FILEPATH
    "Path to perl.exe, from activestate.com or Cygwin") 
    set (MV "move")
    string (REPLACE "/" "\\" FROM "${PROJECT_SOURCE_DIR}/src/core/core_st")
    string (REPLACE "/" "\\" TO "${CMAKE_CURRENT_BINARY_DIR}/core_st")
  else (WIN32)
    set (PERL_EXECUTABLE "perl")
    set (MV "mv")
    set (FROM "${PROJECT_SOURCE_DIR}/src/core/core_st")
    set (TO "${CMAKE_CURRENT_BINARY_DIR}/core_st")
  endif (WIN32)
  set (RC2CPP "${PROJECT_SOURCE_DIR}/Misc/rc2cpp.pl")

  add_custom_command (
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/core_st.cpp ${CMAKE_CURRENT_BINARY_DIR}/core_st.h
    COMMAND "${PERL_EXECUTABLE}" "${RC2CPP}" "${PROJECT_SOURCE_DIR}/src/core/core.rc2"
    COMMAND "${MV}" "${FROM}.cpp" "${TO}.cpp"
    COMMAND "${MV}" "${FROM}.h" "${TO}.h"
    DEPENDS core.rc2
    )
  include_directories(${CMAKE_CURRENT_BINARY_DIR})
else (NOT WIN32 OR WX_WINDOWS)
  list (APPEND CORE_SRCS core.rc2)
endif(NOT WIN32 OR WX_WINDOWS)

add_library(core STATIC ${CORE_SRCS})
target_link_libraries(core PRIVATE harden_interface)

=== src/core/Makefile ===
# Makefile for Linux build of pwsafe
# core library

#CONFIG=debug
#CONFIG=release
CONFIG?=unicodedebug
#CONFIG=unicoderelease

NAME=core

DEPDIR= ./deps

# Following sets WX_CONFIG to 3.0 version if found, else 2.x:
ifeq ($(PLATFORM),FreeBSD)
WX2=/usr/local/bin/wxgtk2y-2.8-config
WX3=/usr/local/bin/wxgtk2u-3.0-config
else ifeq ($(PLATFORM),OpenBSD)
WX3=/usr/local/bin/wx-config
else
WX2=/usr/bin/wx-config
WX3=/usr/bin/wx-config-3.0
endif

WX_CONFIG?=$(shell if [ -e $(WX3) ]; then echo $(WX3); else echo $(WX2); fi)

# Following not used in Linux build
NOTSRC          = PWSclipboard.cpp

LIBSRC          = CheckVersion.cpp \
                  Item.cpp ItemData.cpp ItemAtt.cpp ItemField.cpp  \
                  Match.cpp PolicyManager.cpp PWCharPool.cpp CoreImpExp.cpp \
                  PWPolicy.cpp PWHistory.cpp PWSAuxParse.cpp \
                  PWScore.cpp PWSdirs.cpp PWSfile.cpp PWSfileHeader.cpp \
                  PWSfileV1V2.cpp PWSfileV3.cpp PWSfileV4.cpp \
                  PWSFilters.cpp PWSLog.cpp PWSprefs.cpp \
                  Command.cpp PWSrand.cpp Report.cpp \
                  core_st.cpp RUEList.cpp \
                  StringX.cpp SysInfo.cpp \
                  UnknownField.cpp  \
                  UTF8Conv.cpp Util.cpp CoreOtherDB.cpp \
                  VerifyFormat.cpp XMLprefs.cpp \
                  ExpiredList.cpp PWStime.cpp\
                  pugixml/pugixml.cpp \
                  XML/Pugi/PFileXMLProcessor.cpp XML/Pugi/PFilterXMLProcessor.cpp \
                  XML/XMLFileHandlers.cpp XML/XMLFileValidation.cpp \
                  XML/Xerces/XFileSAX2Handlers.cpp XML/Xerces/XFileValidator.cpp \
                  XML/Xerces/XFileXMLProcessor.cpp XML/Xerces/XFilterSAX2Handlers.cpp \
                  XML/Xerces/XFilterXMLProcessor.cpp XML/Xerces/XSecMemMgr.cpp PWSLog.cpp \
				  RUEList.cpp \
				  crypto/AES.cpp crypto/BlowFish.cpp crypto/pbkdf2.cpp \
				  crypto/KeyWrap.cpp crypto/sha1.cpp crypto/sha256.cpp \
				  crypto/TwoFish.cpp

SRC             = $(LIBSRC)

OBJPATH         = ../../obj/$(CONFIG)/$(NAME)
LIBPATH         = ../../lib/$(CONFIG)

#destination related macros
LIBOBJ    = $(addprefix $(OBJPATH)/,$(subst .cpp,.o,$(LIBSRC)))
LIB       = $(LIBPATH)/libcore.a
OBJ       = $(LIBOBJ)

CPPFLAGS := $(CXXFLAGS) -fPIC -Wall -I. -I.. -I../.. $(CPPFLAGS)

ifeq ($(findstring Darwin, $(shell uname -s)), Darwin)
	    XERCESCPPFLAGS=
		CPPFLAGS += -std=c++11
else
		CPPFLAGS += -DLINUX
	    XERCESCPPFLAGS=-DUSE_XML_LIBRARY=XERCES -DWCHAR_INCOMPATIBLE_XMLCH
endif

ifeq ($(CONFIG),debug)
CPPFLAGS += -O0 -g -ggdb -D_DEBUG -DDEBUG `$(WX_CONFIG) --debug=yes --unicode=no --inplace --cxxflags`
else ifeq ($(CONFIG),release)
CPPFLAGS += -O -DNDEBUG `$(WX_CONFIG) --debug=no --unicode=no --inplace --libs`
else ifeq ($(CONFIG),unicodedebug)
CPPFLAGS += -O0 -g -ggdb -DUNICODE $(XERCESCPPFLAGS) -D_DEBUG -DDEBUG `$(WX_CONFIG) --debug=yes --unicode=yes --inplace --cxxflags`
CFLAGS += -g
else ifeq ($(CONFIG),unicoderelease)
CPPFLAGS += -O -DUNICODE $(XERCESCPPFLAGS) -DNDEBUG `$(WX_CONFIG) --debug=no --unicode=yes --inplace --cxxflags`
endif

# rules
.PHONY: all debug release unicodedebug unicoderelease clean setup

$(OBJPATH)/%.o : %.c
	$(CC) $(CFLAGS)   -c $< -o $@

$(OBJPATH)/%.o : %.cpp
	$(CXX) $(CPPFLAGS) -c $< -o $@

all : setup $(LIB)

debug release unicodedebug unicoderelease:
	$(MAKE) all CONFIG=$@

$(LIB): $(LIBOBJ)
	ar rvus $@ $(filter %.o,$^)

core_st.cpp core_st.h : core.rc2
	../../Misc/rc2cpp.pl $^

StringX.cpp: core_st.h

clean:
	@rm -f *~ $(OBJ) $(TEST) $(LIB)
	@rm -rf $(DEPDIR)
	@rm core_st.cpp core_st.h

setup:
	@mkdir -p $(OBJPATH) $(OBJPATH)/pugixml $(OBJPATH)/crypto $(OBJPATH)/XML/Xerces $(OBJPATH)/XML/Pugi $(LIBPATH) $(DEPDIR)

$(DEPDIR)/%.d: %.cpp
	@set -e; mkdir -p $(DEPDIR) $(DEPDIR)/pugixml $(DEPDIR)/crypto; \
	mkdir -p $(DEPDIR)/XML/Xerces $(DEPDIR)/XML/Pugi; \
	$(RM) $@; \
	$(CXX) -MM $(CPPFLAGS) $< > $@.$$$$; \
	sed 's,\($*\)\.o[ :]*,$(OBJECTPATH)/\1.o $@ : ,g' < $@.$$$$ > $@; \
	$(RM) $@.$$$$

-include $(SRC:%.cpp=$(DEPDIR)/%.d)

=== src/test/CMakeLists.txt ===
set (TEST_SRCS
  AESTest.cpp AliasShortcutTest.cpp FileV3Test.cpp ItemAttTest.cpp OSTest.cpp BlowFishTest.cpp
  FileV4Test.cpp ItemDataTest.cpp SHA256Test.cpp SHA1Test.cpp CommandsTest.cpp ItemFieldTest.cpp
  StringXTest.cpp coretest.cpp HMAC_SHA256Test.cpp HMAC_SHA1Test.cpp KeyWrapTest.cpp TwoFishTest.cpp
  AuxParseTest.cpp UtilTest.cpp FileEncDecTest.cpp ImportTextTest.cpp TOTPTest.cpp Base32Test.cpp)

if (WIN32)
  list (APPEND TEST_SRCS ../core/core.rc2)
  set_source_files_properties(../core/core.rc2 PROPERTIES LANGUAGE RC)
endif(WIN32)


# Setup test data
file (MAKE_DIRECTORY "data")
file (COPY "data/image1.jpg" DESTINATION "data")
file (COPY "data/text1.txt" DESTINATION "data")
file (COPY "data/import-text-unit-test1.txt" DESTINATION "data")
file (COPY "data/import-text-unit-test2.csv" DESTINATION "data")
file (COPY "data/import-text-unit-test3.csv" DESTINATION "data")
file (COPY "data/import-text-unit-test4.csv" DESTINATION "data")
file (COPY "data/import-text-unit-test5.csv" DESTINATION "data")

add_executable(coretest ${TEST_SRCS})
if (MSVC)
set_target_properties(coretest PROPERTIES EXCLUDE_FROM_DEFAULT_BUILD_RELEASE 1)
target_link_libraries(coretest gtest core os Rpcrt4 harden_interface)
elseif (APPLE)
target_link_libraries(coretest gtest core os pthread "-framework CoreFoundation")
else ()
target_link_libraries(coretest gtest core os uuid pthread magic ${wxWidgets_LIBRARIES} Xtst X11)
endif()
if (XercesC_LIBRARY)
  target_link_libraries(coretest ${XercesC_LIBRARY})
endif (XercesC_LIBRARY)

target_link_libraries(coretest harden_interface)

add_test(NAME Coretests
  COMMAND coretest
  )

=== src/ui/Windows/CMakeLists.txt ===

list(APPEND PWSAFE_HDR_LIST
            src/ui/Windows/AboutDlg.h
            src/ui/Windows/AddEdit_Additional.h
            src/ui/Windows/AddEdit_Attachment.h
            src/ui/Windows/AddEdit_Basic.h
            src/ui/Windows/AddEdit_DateTimes.h
            src/ui/Windows/AddEdit_PasswordPolicy.h
            src/ui/Windows/AddEdit_PropertyPage.h
            src/ui/Windows/AddEdit_PropertySheet.h
            src/ui/Windows/AdvancedDlg.h
            src/ui/Windows/AdvancedValues.h
            src/ui/Windows/ClearQuestionDlg.h
            src/ui/Windows/ColumnChooserDlg.h
            src/ui/Windows/ColumnChooserLC.h
            src/ui/Windows/CompareResultsDlg.h
            src/ui/Windows/CompareWithSelectDlg.h
            src/ui/Windows/ConfirmDeleteDlg.h
            src/ui/Windows/ControlExtns.h
            src/ui/Windows/CoolMenu.h
            src/ui/Windows/CreateShortcutDlg.h
            src/ui/Windows/CryptKeyEntry.h
            src/ui/Windows/CWTreeCtrl.h
            src/ui/Windows/DboxMain.h
            src/ui/Windows/DDStatic.h
            src/ui/Windows/DDSupport.h
            src/ui/Windows/DisplayAuthCodeDlg.h
            src/ui/Windows/DisplayFSBkupFiles.h
            src/ui/Windows/DropSource.h
            src/ui/Windows/DropTarget.h
            src/ui/Windows/DumpSelect.h
            src/ui/Windows/EBListCtrl.h
            src/ui/Windows/EditShortcutDlg.h
            src/ui/Windows/EntryKBHotKey.h
            src/ui/Windows/ExcludeCaptureStateBitmapManager.h
            src/ui/Windows/ExpPswdLC.h
            src/ui/Windows/ExpPWListDlg.h
            src/ui/Windows/ExtThread.h
            src/ui/Windows/filter/FilterBaseDlg.h
            src/ui/Windows/filter/FilterBoolDlg.h
            src/ui/Windows/filter/FilterDateDlg.h
            src/ui/Windows/filter/FilterDCADlg.h
            src/ui/Windows/filter/FilterEntrySizeDlg.h
            src/ui/Windows/filter/FilterEntryStatusDlg.h
            src/ui/Windows/filter/FilterEntryTypeDlg.h
            src/ui/Windows/filter/FilterIntegerDlg.h
            src/ui/Windows/filter/FilterMediaTypeDlg.h
            src/ui/Windows/filter/FilterPasswordDlg.h
            src/ui/Windows/filter/FilterStringDlg.h
            src/ui/Windows/filter/ManageFiltersDlg.h
            src/ui/Windows/filter/PWFilterLC.h
            src/ui/Windows/filter/PWFiltersDlg.h
            src/ui/Windows/filter/SetAttachmentFiltersDlg.h
            src/ui/Windows/filter/SetFiltersDlg.h
            src/ui/Windows/filter/SetHistoryFiltersDlg.h
            src/ui/Windows/filter/SetPolicyFiltersDlg.h
            src/ui/Windows/Fonts.h
            src/ui/Windows/FontsDialog.h
            src/ui/Windows/GeneralMsgBox.h
            src/ui/Windows/GridListCtrl.h
            src/ui/Windows/HKModifiers.h
            src/ui/Windows/ImgStatic.h
            src/ui/Windows/ImportTextDlg.h
            src/ui/Windows/ImportXMLDlg.h
            src/ui/Windows/InfoDisplay.h
            src/ui/Windows/InputBox.h
            src/ui/Windows/InvokeGuiThreadSupport.h
            src/ui/Windows/LVHdrCtrl.h
            src/ui/Windows/ManagePSWDPols.h
            src/ui/Windows/MenuShortcuts.h
            src/ui/Windows/MenuTipper.h
            src/ui/Windows/MFCmessages.h
            src/ui/Windows/OptionsBackup.h
            src/ui/Windows/OptionsDisplay.h
            src/ui/Windows/OptionsMisc.h
            src/ui/Windows/OptionsPasswordHistory.h
            src/ui/Windows/OptionsSecurity.h
            src/ui/Windows/OptionsShortcuts.h
            src/ui/Windows/OptionsSystem.h
            src/ui/Windows/Options_PropertyPage.h
            src/ui/Windows/Options_PropertySheet.h
            src/ui/Windows/PasskeyChangeDlg.h
            src/ui/Windows/PasskeyEntry.h
            src/ui/Windows/PasskeySetup.h
            src/ui/Windows/PasswordPolicyDlg.h
            src/ui/Windows/PasswordSafe.h
            src/ui/Windows/PasswordSubsetDlg.h
            src/ui/Windows/PKBaseDlg.h
            src/ui/Windows/ProgressPieCommon.h
            src/ui/Windows/ProgressPieCtrl.h
            src/ui/Windows/ProgressPieStaticCtrl.h
            src/ui/Windows/Properties.h
            src/ui/Windows/PupText.h
            src/ui/Windows/PWDialog.h
            src/ui/Windows/PWFileDialog.h
            src/ui/Windows/PWFindToolBar.h
            src/ui/Windows/PWHdrCtrlNoChng.h
            src/ui/Windows/PWHistListCtrl.h
            src/ui/Windows/PWListCtrl.h
            src/ui/Windows/PWPListEntries.h
            src/ui/Windows/PWPropertyPage.h
            src/ui/Windows/PWPropertySheet.h
            src/ui/Windows/PWResizeDialog.h
            src/ui/Windows/PWSclipboard.h
            src/ui/Windows/PWSFaultHandler.h
            src/ui/Windows/PWSRecentFileList.h
            src/ui/Windows/PWStatusBar.h
            src/ui/Windows/PWSversion.h
            src/ui/Windows/PWToolBar.h
            src/ui/Windows/PWTouch.h
            src/ui/Windows/PWTreeCtrl.h
            src/ui/Windows/QuerySetDef.h
            src/ui/Windows/resource.h
            src/ui/Windows/resource2.h
            src/ui/Windows/resource3.h
            src/ui/Windows/RichEditCtrlExtn.h
            src/ui/Windows/SampleTextDlg.h
            src/ui/Windows/SCWListCtrl.h
            src/ui/Windows/ScreenCaptureStateControl.h
            src/ui/Windows/SecString.h
            src/ui/Windows/SetDBID.h
            src/ui/Windows/SHCTHotKey.h
            src/ui/Windows/SHCTListCtrl.h
            src/ui/Windows/Shortcut.h
            src/ui/Windows/ShowCompareDlg.h
            src/ui/Windows/SingleInstance.h
            src/ui/Windows/SMemFile.h
            src/ui/Windows/StateBitmapControl.h
            src/ui/Windows/StateBitmapManager.h
            src/ui/Windows/StdAfx.h
            src/ui/Windows/Subclass.h
            src/ui/Windows/SysColStatic.h
            src/ui/Windows/SystemTray.h
            src/ui/Windows/TBMStatic.h
            src/ui/Windows/ThisMfcApp.h
            src/ui/Windows/ViewReport.h
            src/ui/Windows/ViewAttachmentDlg.h
            src/ui/Windows/VirtualKeyboard/VKBButton.h
            src/ui/Windows/VirtualKeyboard/VKeyBoardDlg.h
            src/ui/Windows/VirtualKeyboard/VKresource.h
            src/ui/Windows/VirtualKeyboard/VKresource3.h
            src/ui/Windows/VirtualKeyboard/VKShiftState.h
            src/ui/Windows/Windowsdefs.h
            src/ui/Windows/winutils.h
            src/ui/Windows/WZAdvanced.h
            src/ui/Windows/WZExecuteThreadParms.h
            src/ui/Windows/WZFinish.h
            src/ui/Windows/WZPropertyPage.h
            src/ui/Windows/WZPropertySheet.h
            src/ui/Windows/WZSelectDB.h
    )


list(APPEND PWSAFE_SRC_LIST
            src/ui/Windows/AboutDlg.cpp
            src/ui/Windows/AddEdit_Additional.cpp
            src/ui/Windows/AddEdit_Attachment.cpp
            src/ui/Windows/AddEdit_Basic.cpp
            src/ui/Windows/AddEdit_DateTimes.cpp
            src/ui/Windows/AddEdit_PasswordPolicy.cpp
            src/ui/Windows/AddEdit_PropertyPage.cpp
            src/ui/Windows/AddEdit_PropertySheet.cpp
            src/ui/Windows/AdvancedDlg.cpp
            src/ui/Windows/ClearQuestionDlg.cpp
            src/ui/Windows/ColumnChooserDlg.cpp
            src/ui/Windows/ColumnChooserLC.cpp
            src/ui/Windows/CompareResultsDlg.cpp
            src/ui/Windows/CompareWithSelectDlg.cpp
            src/ui/Windows/ConfirmDeleteDlg.cpp
            src/ui/Windows/ControlExtns.cpp
            src/ui/Windows/CoolMenu.cpp
            src/ui/Windows/CreateShortcutDlg.cpp
            src/ui/Windows/CryptKeyEntry.cpp
            src/ui/Windows/CWTreeCtrl.cpp
            src/ui/Windows/DboxMain.cpp
            src/ui/Windows/DboxTray.cpp
            src/ui/Windows/DDStatic.cpp
            src/ui/Windows/DDSupport.cpp
            src/ui/Windows/DisplayAuthCodeDlg.cpp
            src/ui/Windows/DisplayFSBkupFiles.cpp
            src/ui/Windows/DropSource.cpp
            src/ui/Windows/DropTarget.cpp
            src/ui/Windows/DumpSelect.cpp
            src/ui/Windows/EBListCtrl.cpp
            src/ui/Windows/EditShortcutDlg.cpp
            src/ui/Windows/EntryKBHotKey.cpp
            src/ui/Windows/ExcludeCaptureStateBitmapManager.cpp
            src/ui/Windows/ExpPswdLC.cpp
            src/ui/Windows/ExpPWListDlg.cpp
            src/ui/Windows/ExtThread.cpp
            src/ui/Windows/filter/FilterBaseDlg.cpp
            src/ui/Windows/filter/FilterBoolDlg.cpp
            src/ui/Windows/filter/FilterDateDlg.cpp
            src/ui/Windows/filter/FilterDCADlg.cpp
            src/ui/Windows/filter/FilterEntrySizeDlg.cpp
            src/ui/Windows/filter/FilterEntryStatusDlg.cpp
            src/ui/Windows/filter/FilterEntryTypeDlg.cpp
            src/ui/Windows/filter/FilterIntegerDlg.cpp
            src/ui/Windows/filter/FilterMediaTypeDlg.cpp
            src/ui/Windows/filter/FilterPasswordDlg.cpp
            src/ui/Windows/filter/FilterStringDlg.cpp
            src/ui/Windows/filter/ManageFiltersDlg.cpp
            src/ui/Windows/filter/PWFilterLC.cpp
            src/ui/Windows/filter/PWFiltersDlg.cpp
            src/ui/Windows/filter/SetAttachmentFiltersDlg.cpp
            src/ui/Windows/filter/SetFiltersDlg.cpp
            src/ui/Windows/filter/SetHistoryFiltersDlg.cpp
            src/ui/Windows/filter/SetPolicyFiltersDlg.cpp
            src/ui/Windows/Fonts.cpp
            src/ui/Windows/FontsDialog.cpp
            src/ui/Windows/GeneralMsgBox.cpp
            src/ui/Windows/GridListCtrl.cpp
            src/ui/Windows/ImgStatic.cpp
            src/ui/Windows/ImportTextDlg.cpp
            src/ui/Windows/ImportXMLDlg.cpp
            src/ui/Windows/InfoDisplay.cpp
            src/ui/Windows/InputBox.cpp
            src/ui/Windows/LVHdrCtrl.cpp
            src/ui/Windows/main.cpp
            src/ui/Windows/MainEdit.cpp
            src/ui/Windows/MainFile.cpp
            src/ui/Windows/MainFilters.cpp
            src/ui/Windows/MainManage.cpp
            src/ui/Windows/MainMenu.cpp
            src/ui/Windows/MainView.cpp
            src/ui/Windows/ManagePSWDPols.cpp
            src/ui/Windows/MenuShortcuts.cpp
            src/ui/Windows/MenuTipper.cpp
            src/ui/Windows/OptionsBackup.cpp
            src/ui/Windows/OptionsDisplay.cpp
            src/ui/Windows/OptionsMisc.cpp
            src/ui/Windows/OptionsPasswordHistory.cpp
            src/ui/Windows/OptionsSecurity.cpp
            src/ui/Windows/OptionsShortcuts.cpp
            src/ui/Windows/OptionsSystem.cpp
            src/ui/Windows/Options_PropertyPage.cpp
            src/ui/Windows/Options_PropertySheet.cpp
            src/ui/Windows/PasskeyChangeDlg.cpp
            src/ui/Windows/PasskeyEntry.cpp
            src/ui/Windows/PasskeySetup.cpp
            src/ui/Windows/PasswordPolicyDlg.cpp
            src/ui/Windows/PasswordSubsetDlg.cpp
            src/ui/Windows/PKBaseDlg.cpp
            src/ui/Windows/ProgressPieCommon.cpp
            src/ui/Windows/ProgressPieCtrl.cpp
            src/ui/Windows/ProgressPieStaticCtrl.cpp
            src/ui/Windows/Properties.cpp
            src/ui/Windows/PupText.cpp
            src/ui/Windows/PWDialog.cpp
            src/ui/Windows/PWFileDialog.cpp
            src/ui/Windows/PWFindToolBar.cpp
            src/ui/Windows/PWHdrCtrlNoChng.cpp
            src/ui/Windows/PWHistListCtrl.cpp
            src/ui/Windows/PWListCtrl.cpp
            src/ui/Windows/PWPListEntries.cpp
            src/ui/Windows/PWPropertyPage.cpp
            src/ui/Windows/PWPropertySheet.cpp
            src/ui/Windows/PWResizeDialog.cpp
            src/ui/Windows/PWSclipboard.cpp
            src/ui/Windows/PWSFaultHandler.cpp
            src/ui/Windows/PWSRecentFileList.cpp
            src/ui/Windows/PWStatusBar.cpp
            src/ui/Windows/PWSversion.cpp
            src/ui/Windows/PWToolBar.cpp
            src/ui/Windows/PWTreeCtrl.cpp
            src/ui/Windows/QuerySetDef.cpp
            src/ui/Windows/RichEditCtrlExtn.cpp
            src/ui/Windows/SampleTextDlg.cpp

=== src/ui/Windows/I18N/CMakeLists.txt ===
# CMakeLists.txt for pwsafe I18N support:
#
# Supports making language-specific DLLs
# Supports updating language-specific .po files
# Supports creating pwsafe.pot file as the basis for a new translation
#

set(BASE_DLL "$<TARGET_FILE:pwsafe_base>")

set (DLL_DIR "${CMAKE_BINARY_DIR}/I18N")

set(POT_INPUT "${CMAKE_CURRENT_SOURCE_DIR}/pwsafe.pot")
set(POT_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/pwsafe.pot")

add_custom_command(
  OUTPUT "${POT_OUTPUT}"
  DEPENDS pwsafe_base "${POT_INPUT}"
  COMMAND "${CMAKE_COMMAND}" -E copy "${POT_INPUT}" "${POT_OUTPUT}"
  COMMAND ResText extract -noupdate "${BASE_DLL}" "${POT_OUTPUT}"
  COMMENT "Updating pwsafe.pot from ${BASE_DLL} using ${RESTEXT}"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  VERBATIM
)

option(USE_EXISTING_TRANSLATIONS "Use the .po files from the source tree when building the translation DLLs.  When disabled, the DLLs will be built with updated .po files." ON)

file(MAKE_DIRECTORY pos)
file(MAKE_DIRECTORY tmp)

unset(LANG_POS)
unset(LANG_DLLS)

macro( make_dll LANG CODE OUT)
  set(PO_INPUT "${CMAKE_CURRENT_SOURCE_DIR}/pos/pwsafe_${LANG}.po")
  set(PO_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/pos/pwsafe_${LANG}.po")

  add_custom_command(
    OUTPUT "${PO_OUTPUT}"
    DEPENDS pwsafe_base "${PO_INPUT}"
    COMMAND "${CMAKE_COMMAND}" -E copy "${PO_INPUT}" "${PO_OUTPUT}"
    COMMAND ResText extract "${BASE_DLL}" "${PO_OUTPUT}"
    COMMENT "Updating pwsafe_${LANG}.po using ${RESTEXT}"
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    VERBATIM
  )

  list(APPEND LANG_POS "${PO_OUTPUT}")

  string (TOUPPER ${LANG} UCLANG)
  set(TEMP_DLL "tmp/pwsafe_${LANG}-tmp.dll")
  set(CODE_DLL "tmp/pwsafe${OUT}.dll")
  set(OUT_DLL "${DLL_DIR}/pwsafe${UCLANG}.dll")

  if (USE_EXISTING_TRANSLATIONS)
    set(PO_FILE "${PO_INPUT}")
  else ()
    set(PO_FILE "${PO_OUTPUT}")
  endif ()

  add_custom_command(
    OUTPUT "${TEMP_DLL}"
    DEPENDS pwsafe_base "${PO_FILE}"
    COMMAND ResText apply "${BASE_DLL}" "${TEMP_DLL}" "${PO_FILE}"
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    COMMENT "Making ${TEMP_DLL} from ${BASE_DLL} and pos/pwsafe_${LANG}.po"
    VERBATIM
  )

  add_custom_command(
    OUTPUT "${CODE_DLL}"
    DEPENDS "${TEMP_DLL}"
    COMMAND ResPWSL apply "${TEMP_DLL}" "${CODE}"
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    COMMENT "Making ${CODE_DLL} from ${TEMP_DLL} for ${CODE}"
    VERBATIM
  )

  add_custom_command(
    OUTPUT "${OUT_DLL}"
    DEPENDS "${CODE_DLL}"
    COMMAND "${CMAKE_COMMAND}" -E copy_if_different "${CODE_DLL}" "${OUT_DLL}"
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    COMMENT "Copying ${CODE_DLL} to ${OUT_DLL}"
    VERBATIM
  )

  list(APPEND LANG_DLLS "${OUT_DLL}")
endmacro( make_dll LANG CODE )

make_dll(ar    0x2c01 AR_JO)
make_dll(cz    0x0405 CS_CZ)
make_dll(de    0x0407 DE_DE)
make_dll(dk    0x0406 DA_DK)
make_dll(es    0x0c0a ES_ES)
make_dll(fr    0x040c FR_FR)
make_dll(hu    0x040e HU_HU)
make_dll(it    0x0410 IT_IT)
make_dll(kr    0x0412 KO_KR)
make_dll(lv    0x0426 LV_LV)
make_dll(nl    0x0413 NL_NL)
make_dll(pl    0x0415 PL_PL)
make_dll(pt_br 0x0416 PT_BR)
make_dll(ru    0x0419 RU_RU)
make_dll(sv    0x041d SV_SE)
make_dll(sl    0x0424 SL_SI)
make_dll(tr    0x041f TR_TR)
make_dll(zh    0x0804 ZH_CN)

add_custom_target(language-dlls DEPENDS ${LANG_DLLS})

set_property(TARGET language-dlls PROPERTY FOLDER I18N)

# Don't update the in-tree pwsafe.pot unless the user builds this target.
add_custom_target(update-pot
  DEPENDS "${POT_OUTPUT}"
  COMMAND "${CMAKE_COMMAND}" -E copy_if_different "${POT_OUTPUT}" "${POT_INPUT}"
  VERBATIM
)
set_property(TARGET update-pot PROPERTY FOLDER I18N)

# Don't update the in-tree .po files unless the user builds this target.
add_custom_target(update-pos
  DEPENDS ${LANG_POS}
  COMMAND "${CMAKE_COMMAND}" -E copy_if_different ${LANG_POS} "${CMAKE_CURRENT_SOURCE_DIR}/pos"
  VERBATIM
)
set_property(TARGET update-pos PROPERTY FOLDER I18N)

add_custom_target(update-translations DEPENDS update-pot update-pos)
set_property(TARGET update-translations PROPERTY FOLDER I18N)

=== src/ui/Windows/I18N/Makefile ===
# This Makefile is used to automate the internationalization support
# of PasswordSafe.
#
# There are two main processes related to i18n:
# 1. Updating the input files (.po & .pot)
# 2. Generating dlls from translated po files
#
# - pwsafe.pot is the raw input file for translation, serves as a
#   basis for all new translations
# - pwsafe*.po are translations to a given language/locale.
# - The above are generates/updated from the $(BASE_DLL).
#
# The list of LCIDs is at
# https://msdn.microsoft.com/en-us/library/cc233982.aspx
#

#Update the following for each language we support

POS := pwsafe.pot pos/pwsafe_ar.po \
	pos/pwsafe_cz.po pos/pwsafe_es.po pos/pwsafe_de.po \
	pos/pwsafe_pl.po pos/pwsafe_zh.po pos/pwsafe_ru.po \
	pos/pwsafe_it.po pos/pwsafe_fr.po pos/pwsafe_dk.po \
	pos/pwsafe_kr.po pos/pwsafe_sv.po pos/pwsafe_nl.po \
	pos/pwsafe_tr.po pos/pwsafe_hu.po pos/pwsafe_sl.po \
	pos/pwsafe_pt_br.po pos/pwsafe_lv.po

DLL_LIST = pwsafeAR.dll pwsafeCZ.dll pwsafeES.dll pwsafeDE.dll \
	pwsafePL.dll pwsafeZH.dll pwsafeRU.dll pwsafeIT.dll pwsafeFR.dll \
	pwsafeDA.dll pwsafeKR.dll pwsafeNL.dll pwsafeSV.dll pwsafeTR.dll \
	pwsafeHU.dll pwsafeSL.dll pwsafePT.dll pwsafeLV.dll

DEST_DIR := ../../../../out/build/windows-x86-Release/I18N
DEST_DIR_64 := ../../../../out/build/windows-x64-Release/I18N
DLLS = $(DLL_LIST:%=$(DEST_DIR)/%)
DLLS_64 = $(DLL_LIST:%=$(DEST_DIR_64)/%)

TOOLS_SRC_DIR := ../../../Tools/Windows/I18N
TOOLS_BIN_DIR := ../../../../out/build/windows-x64-Release/src/Tools/Windows/I18N

CHECK_PO := ../../../../Misc/check_po.py

help:
	@echo "Make one of:"
	@echo "update-pos dlls tools clean check help"

# No need to change anything below this line
RESTEXT = $(TOOLS_BIN_DIR)/ResText/ResText.exe
RESPWSL = $(TOOLS_BIN_DIR)/ResPWSL/ResPWSL.exe
CHMOD = /usr/bin/chmod
RM = /usr/bin/rm
MV = /usr/bin/mv

BASE_DLL = ../../../../out/build/windows-x86-release/src/ui/Windows/language/pwsafe_base.dll
BASE_DLL_64 = ../../../../out/build/windows-x64-release/src/ui/Windows/language/pwsafe_base.dll

.PHONY: update-pos dlls dlls_32 dlls_64 tools clean help check dest_dir

update-pos: tools $(POS)

# All of the .po files depend on the pwsafe_base.dll from the languageDLL project
# Making it dependent on both x86 and x64 versions, just in case only one's updated when this is run.
$(POS): $(BASE_DLL) $(BASE_DLL_64)

# How to make a .po file from pwsafe_base.dll
%.po: $(BASE_DLL)
	$(RESTEXT) extract $^ $@

pwsafe.pot: tools $(BASE_DLL)
	$(RESTEXT) extract -noupdate $(BASE_DLL) $@

dest_dir :
	@mkdir -p $(DEST_DIR)

# Originally, this rule triggered the individual DLL rules above
# However, we now use the VB scripts to make the language DLLs
dlls : tools dest_dir dlls_32 dlls_64

# The issue with the VB scripts is that they have built-in pauses that stop the makefile
dlls_32:
	cscript Create_DLLs.vbs -quiet x86

dlls_64:
	cscript Create_DLLs.vbs -quiet x64

# TODO fix
tools : 
	@echo "tools assumed updated"
#	$(MAKE) -C $(TOOLS_SRC_DIR)

# TODO
check :
	python $(CHECK_PO) $(POS)

# TODO
clean :
	$(MAKE) -C $(TOOLS_SRC_DIR) clean

=== src/Tools/Windows/I18N/ResPWSL/CMakeLists.txt ===
set (RESPWSL_SRCS
    ResPWSL.cpp
    StdAfx.cpp
    StringFileInfo.cpp
    StringTable.cpp
    VersionInfo.cpp
    VersionInfoBuffer.cpp
    VersionInfoString.cpp
)

set (RESPWSL_RES ResPWSL.rc)

add_executable( ResPWSL ${RESPWSL_SRCS} ${RESPWSL_RES})
target_link_libraries( ResPWSL PRIVATE harden_interface )

set_property( TARGET ResPWSL
              PROPERTY FOLDER Tools )
              
target_compile_definitions(ResPWSL PRIVATE 
              _CRT_SECURE_NO_WARNINGS 
              _CRT_NON_CONFORMING_SWPRINTFS)

=== src/Tools/Windows/I18N/ResText/CMakeLists.txt ===
set (RESTEXT_SRCS
    codecvt.cpp
    POFile.cpp
    ResModule.cpp
    ResText.cpp
    stdafx.cpp
    UnicodeUtils.cpp
    Utils.cpp
)

set (RESTEXT_RES ResText.rc)

add_executable( ResText ${RESTEXT_SRCS} ${RESTEXT_RES})
target_link_libraries( ResText harden_interface )

set_property( TARGET ResText
              PROPERTY FOLDER Tools )
              
target_compile_definitions(ResText PRIVATE 
              _CRT_SECURE_NO_WARNINGS 
              _CRT_NON_CONFORMING_SWPRINTFS)

=== install/arch/PKGBUILD ===
# PKGBUILD

pkgname=pwsafe
pkgver=1.19.1fp1
pkgrel=1
pkgdesc="PasswordSafe password manager"
arch=('x86_64')
url="https://github.com/pwsafe/pwsafe/archive/refs/tags"
license=('Artistic 2.0')
depends=('libxt' 'qrencode' 'wxwidgets-gtk3' 'xerces-c' 'yubikey-personalization')
makedepends=('cmake')
source=("$url/$pkgver.tar.gz")
sha256sums=('61fdddb7bf51c6f8d144fdf6421e87160143a9a4be7547598e76fb55047071db')

build() {
    cd "$srcdir/$pkgname-$pkgver"
    mkdir build
    cd build
    cmake -DCMAKE_INSTALL_PREFIX=/usr ..
    make
}

package() {
    cd "$srcdir/$pkgname-$pkgver/build"
    make DESTDIR="$pkgdir/" install
}
